Index: lib/libutil/expand_number.c
===================================================================
--- lib/libutil/expand_number.c	(revision 254600)
+++ lib/libutil/expand_number.c	(working copy)
@@ -50,15 +50,22 @@
 expand_number(const char *buf, uint64_t *num)
 {
 	uint64_t number;
+	int saved_errno;
 	unsigned shift;
 	char *endptr;
 
+	saved_errno = errno;
+	errno = 0;
+
 	number = strtoumax(buf, &endptr, 0);
 
 	if (number == UINTMAX_MAX && errno == ERANGE) {
 		return (-1);
 	}
 
+	if (errno == 0)
+		errno = saved_errno;
+
 	if (endptr == buf) {
 		/* No valid digits. */
 		errno = EINVAL;
